<?php

namespace UserBundle\Repository;

use Psr\Log\LoggerInterface;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use UserBundle\Entity\ShippingAddress;
use UserBundle\Entity\User;
use Utils\StaticUtil\LogUtils;

/**
 * ShippingAddressRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ShippingAddressRepository extends SchemaEntityRepository {

    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * ShippingAddressRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, ShippingAddress::class);

        $this->logger = $logger;
    }

    /**
     * @param User $user
     * @param string $order
     * @return array|mixed
     */
    public function findActiveLastUsedByUser (User &$user, $order='DESC') {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('sa')
            ->from('UserBundle:ShippingAddress', 'sa')
            ->where('(sa.isDisabled IS NULL OR sa.isDisabled=0) AND sa.user=:user')
            ->setParameter('user', $user)
            ->orderBy('sa.lastUsedAt', $order);
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all active last used address by userId:". $user->getId(), $exception);
        }

        return $results;
    }

    /**
     * @param User $user
     * @return mixed|null
     */
    public function findCountAddresses (User &$user) {

        $qb = $this->getEntityManager()->createQuery(
            'SELECT count(0) AS counted 
                  FROM UserBundle:ShippingAddress sa
                  WHERE (sa.isDisabled IS NULL OR sa.isDisabled=0) AND sa.user = :currentUser'
            )
            ->setParameter('currentUser', $user)
        ;

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get count shipping addresses", $exception);
        }

        return $result;
    }

}
